	module Gauge_boson_2p
        use SM_const
	use pv
	implicit none
!---------------------------------------------------
	contains

!#############################
!
!  FERMION-LOOP CONTRIBUTIONS TO GAUGE BOSON 2-POINT FUNCTIONS
!
!#############################
!---------------------------------------------
	double complex function PiWW_F(qsq)
	double precision, intent(in):: qsq

	PiWW_F=&
	 g**2/(16.d0*pi**2)*3.d0*&
	(&
	 -b4f(qsq,mt,mb)+2.d0*qsq*b3f(qsq,mt,mb)&
	 )&
!
	+ g**2/(16.d0*pi**2)*3.d0*&
	 (&
	-b4f(qsq,mc,ms)+2.d0*qsq*b3f(qsq,mc,ms)&
	 )&
!
	+ g**2/(16.d0*pi**2)*3.d0*&
	 (&
	-b4f(qsq,m0,m0)+2.d0*qsq*b3f(qsq,m0,m0)&
	 )&
!
	+ g**2/(16.d0*pi**2)*&
	(&
	 -b4f(qsq,mtau,m0)+2.d0*qsq*b3f(qsq,mtau,m0)&
	 )&
!
	 +g**2/(16.d0*pi**2)*&
	(&
	  +2.d0*qsq*b3f(qsq,m0,m0)&
	 )*2.d0

	
	 end function
!--------------------------------------------
	double complex function PiGG_F(qsq)
	double precision, intent(in):: qsq

	 PiGG_F=&
	 g**2*sw**2/(16.d0*pi**2)*Nc*Qt**2*&
	( 8.d0*qsq*b3f(qsq,mt,mt))&
!
	 +g**2*sw**2/(16.d0*pi**2)*Nc*Qt**2*&
	( 8.d0*qsq*b3f(qsq,mc,mc))&
!
	 +g**2*sw**2/(16.d0*pi**2)*Nc*Qt**2*&
	( 8.d0*qsq*b3f(qsq,m0,m0) )&
!
	 +g**2*sw**2/(16.d0*pi**2)*Nc*Qb**2*&
	( 8.d0*qsq*b3f(qsq,mb,mb))&
!
	 +g**2*sw**2/(16.d0*pi**2)*Nc*Qb**2*&
	( 8.d0*qsq*b3f(qsq,ms,ms))&
!
	 +g**2*sw**2/(16.d0*pi**2)*Nc*Qb**2*&
	( 8.d0*qsq*b3f(qsq,m0,m0) )&
!
	 +g**2*sw**2/(16.d0*pi**2)*Qe**2*&
	( 8.d0*qsq*b3f(qsq,mtau,mtau) )&
!
	 +g**2*sw**2/(16.d0*pi**2)*Qe**2*&
	( 8.d0*qsq*b3f(qsq,m0,m0) )*2.d0
!


	 end function
!--------------------------------------------
	double complex function PiZG_F(qsq)
	double precision, intent(in):: qsq

	PiZG_F=&
	 g**2*sw/cw/(16.d0*pi**2)*Nc*2.d0*qsq*&
	(-4.d0*sw**2*Qt**2+2.d0*It*Qt)*b3f(qsq,mt,mt)&
!
	 +g**2*sw/cw/(16.d0*pi**2)*Nc*2.d0*qsq*&
	(-4.d0*sw**2*Qt**2+2.d0*It*Qt)*b3f(qsq,mc,mc)&
!
	 +g**2*sw/cw/(16.d0*pi**2)*Nc*2.d0*qsq*&
	(-4.d0*sw**2*Qt**2+2.d0*It*Qt)*b3f(qsq,m0,m0)&
!
	 +g**2*sw/cw/(16.d0*pi**2)*Nc*2.d0*qsq*&
	(-4.d0*sw**2*Qb**2+2.d0*Ib*Qb)*b3f(qsq,mb,mb)&
!
	 +g**2*sw/cw/(16.d0*pi**2)*Nc*2.d0*qsq*&
	(-4.d0*sw**2*Qb**2+2.d0*Ib*Qb)*b3f(qsq,ms,ms)&
!
	 +g**2*sw/cw/(16.d0*pi**2)*Nc*2.d0*qsq*&
	(-4.d0*sw**2*Qb**2+2.d0*Ib*Qb)*b3f(qsq,m0,m0)&
!
	 +g**2*sw/cw/(16.d0*pi**2)*2.d0*qsq*&
	(-4.d0*sw**2*Qe**2 +2.d0*Ib*Qe )*b3f(qsq,mtau,mtau)&
!
	 +g**2*sw/cw/(16.d0*pi**2)*2.d0*qsq*&
	(-4.d0*sw**2*Qe**2 +2.d0*Ib*Qe )*b3f(qsq,m0,m0)*2.d0


	 end function
!--------------------------------------------
	double complex function PiZZ_F(qsq)
	double precision, intent(in):: qsq

	PiZZ_F=&
	  g**2/cw**2/(16.d0*pi**2)*3.d0*&
	  (2.d0*qsq*&
	   (4.d0*sw**4*Qt**2-4.d0*sw**2*Qt*It+2.d0*It**2)*b3f(qsq,mt,mt)&
	   -2.d0*It**2*mt**2*b0f(qsq,mt,mt)&
	   )&
!
	  +g**2/cw**2/(16.d0*pi**2)*3.d0*&
	  (2.d0*qsq*&
	   (4.d0*sw**4*Qt**2-4.d0*sw**2*Qt*It+2.d0*It**2)*b3f(qsq,mc,mc)&
	   -2.d0*It**2*mc**2*b0f(qsq,mc,mc)&
	   )&
!
	  +g**2/cw**2/(16.d0*pi**2)*3.d0*&
	  (2.d0*qsq*&
	   (4.d0*sw**4*Qt**2&
	  -4.d0*sw**2*Qt*It+2.d0*It**2)*b3f(qsq,m0,m0)&
	   )&
!
	  +g**2/cw**2/(16.d0*pi**2)*3.d0*&
	  (2.d0*qsq*&
	   (4.d0*sw**4*Qb**2-4.d0*sw**2*Qb*Ib+2.d0*Ib**2)*b3f(qsq,mb,mb)&
	   -2.d0*Ib**2*mb**2*b0f(qsq,mb,mb)&
	   )&
!
	  +g**2/cw**2/(16.d0*pi**2)*3.d0*&
	  (2.d0*qsq*&
	   (4.d0*sw**4*Qb**2-4.d0*sw**2*Qb*Ib+2.d0*Ib**2)*b3f(qsq,ms,ms)&
	   -2.d0*Ib**2*ms**2*b0f(qsq,ms,ms)&
	   )&
!
	  +g**2/cw**2/(16.d0*pi**2)*3.d0*&
	  2.d0*qsq*&
	  (4.d0*sw**4*Qb**2-4.d0*sw**2*Qb*Ib+2.d0*Ib**2)*b3f(qsq,m0,m0)&
!
	  +g**2/cw**2/(16.d0*pi**2)*&
	  (2.d0*qsq*&
	   (4.d0*sw**4*Qe**2-4.d0*sw**2*Qe*Ie+2.d0*Ie**2)*b3f(qsq,mtau,mtau)&
	   -2.d0*Ie**2*mtau**2*b0f(qsq,mtau,mtau)&
	   )&
!
	  +g**2/cw**2/(16.d0*pi**2)*&
	  (2.d0*qsq*&
	   (4.d0*sw**4*Qe**2&
	 -4.d0*sw**2*Qe*Ib+2.d0*Ib**2)*b3f(qsq,m0,m0)*2.d0&
	   )&
!
	  +g**2/cw**2/(16.d0*pi**2)*&
	  (2.d0*qsq*&
	   (2.d0*It**2)*b3f(qsq,m0,m0)&
	   )*3.d0 ! neutrinos

	 end function
!---------------------------------------------
	double complex function dPiWW_F(qsq)
	double precision, intent(in):: qsq

	dPiWW_F =&
	 g**2/(16.d0*pi**2)*3.d0*&
	(-db4f(qsq,mt,mb)+2.d0*b3f(qsq,mt,mb)+2.d0*qsq*db3f(qsq,mt,mb))&
!
	 +g**2/(16.d0*pi**2)*3.d0*&
	(-db4f(qsq,mc,ms)+2.d0*b3f(qsq,mc,ms)+2.d0*qsq*db3f(qsq,mc,ms))&
!
	+ g**2/(16.d0*pi**2)*3.d0*&
	 (-db4f(qsq,m0,m0)+2.d0*b3f(qsq,m0,m0)+2.d0*qsq*db3f(qsq,m0,m0) )&
!
	+ g**2/(16.d0*pi**2)*&
	(&
	 -db4f(qsq,mtau,m0)+2.d0*b3f(qsq,mtau,m0)+2.d0*qsq*db3f(qsq,mtau,m0)&
	 )&
!
	 +g**2/(16.d0*pi**2)*&
	(-db4f(qsq,m0,m0) +2.d0*b3f(qsq,m0,m0)+2.d0*qsq*db3f(qsq,m0,m0) )*2.d0

	
	 end function
!--------------------------------------------
	double complex function dPiGG_F(qsq)
	double precision, intent(in):: qsq

	dPiGG_F=&
	 g**2*sw**2/(16.d0*pi**2)*3.d0*Qt**2*&
	(&
	 8.d0*b3f(qsq,mt,mt)+8.d0*qsq*db3f(qsq,mt,mt)&
	 )&
!
	 +g**2*sw**2/(16.d0*pi**2)*3.d0*Qt**2*&
	(&
	 8.d0*b3f(qsq,mc,mc)+8.d0*qsq*db3f(qsq,mc,mc)&
	 )&
!
	 +g**2*sw**2/(16.d0*pi**2)*3.d0*Qt**2*&
	(&
	 8.d0*b3f(qsq,m0,m0)+8.d0*qsq*db3f(qsq,m0,m0)&
	 )&
!
	 +g**2*sw**2/(16.d0*pi**2)*3.d0*Qb**2*&
	(&
	 8.d0*b3f(qsq,mb,mb)+8.d0*qsq*db3f(qsq,mb,mb)&
	 )&
!
	 +g**2*sw**2/(16.d0*pi**2)*3.d0*Qb**2*&
	(&
	 8.d0*b3f(qsq,ms,ms)+8.d0*qsq*db3f(qsq,ms,ms)&
	 )&
!
	 +g**2*sw**2/(16.d0*pi**2)*3.d0*Qb**2*&
	(&
	 8.d0*b3f(qsq,m0,m0)+8.d0*qsq*db3f(qsq,m0,m0)&
	 )&
!
	 +g**2*sw**2/(16.d0*pi**2)*Qe**2*&
	(&
	 8.d0*b3f(qsq,mtau,mtau)+8.d0*qsq*db3f(qsq,mtau,mtau)&
	 )&
!
	 +g**2*sw**2/(16.d0*pi**2)*Qe**2*&
	(&
	 8.d0*b3f(qsq,m0,m0)+8.d0*qsq*db3f(qsq,m0,m0)&
	 )*2.d0


	 end function
!--------------------------------------------
	double complex function dPiZG_F(qsq)
	double precision, intent(in):: qsq

	dPiZG_F=&
	 g**2*sw/cw/(16.d0*pi**2)*Nc*2.d0*qsq*&
	(-4.d0*sw**2*Qt**2+2.d0*It*Qt)*db3f(qsq,mt,mt)&
!
	 +g**2*sw/cw/(16.d0*pi**2)*Nc*2.d0*qsq*&
	(-4.d0*sw**2*Qt**2+2.d0*It*Qt)*db3f(qsq,mc,mc)&
!
	 +g**2*sw/cw/(16.d0*pi**2)*Nc*2.d0*qsq*&
	(-4.d0*sw**2*Qt**2+2.d0*It*Qt)*db3f(qsq,m0,m0)&
!
	 +g**2*sw/cw/(16.d0*pi**2)*Nc*2.d0*qsq*&
	(-4.d0*sw**2*Qb**2+2.d0*Ib*Qb)*db3f(qsq,mb,mb)&
!
	 +g**2*sw/cw/(16.d0*pi**2)*Nc*2.d0*qsq*&
	(-4.d0*sw**2*Qb**2+2.d0*Ib*Qb)*db3f(qsq,ms,ms)&
!
	 +g**2*sw/cw/(16.d0*pi**2)*Nc*2.d0*qsq*&
	(-4.d0*sw**2*Qb**2+2.d0*Ib*Qb)*db3f(qsq,m0,m0)&
!
	 +g**2*sw/cw/(16.d0*pi**2)*2.d0*qsq*&
	(-4.d0*sw**2*Qe**2 +2.d0*Ib*Qe )*db3f(qsq,m0,m0)*3.d0&
!!!
	 +g**2*sw/cw/(16.d0*pi**2)*Nc*2.d0*&
	(-4.d0*sw**2*Qt**2+2.d0*It*Qt)*b3f(qsq,mt,mt)&
!
	 +g**2*sw/cw/(16.d0*pi**2)*Nc*2.d0*&
	(-4.d0*sw**2*Qt**2+2.d0*It*Qt)*b3f(qsq,m0,m0)*2.d0&
!
	 +g**2*sw/cw/(16.d0*pi**2)*Nc*2.d0*&
	(-4.d0*sw**2*Qb**2+2.d0*Ib*Qb)*b3f(qsq,mb,mb)&
!
	 +g**2*sw/cw/(16.d0*pi**2)*Nc*2.d0*&
	(-4.d0*sw**2*Qb**2+2.d0*Ib*Qb)*b3f(qsq,m0,m0)*2.d0&
!
	 +g**2*sw/cw/(16.d0*pi**2)*2.d0*&
	(-4.d0*sw**2*Qe**2+2.d0*Ie*Qe)*b3f(qsq,mtau,mtau)&
!
	 +g**2*sw/cw/(16.d0*pi**2)*2.d0*&
	(-4.d0*sw**2*Qe**2 +2.d0*Ib*Qe )*b3f(qsq,m0,m0)*2.d0

	 end function
!--------------------------------------------
	double complex function dPiZZ_F(qsq)
	double precision, intent(in):: qsq

	dPiZZ_F=&
	  g**2/cw**2/(16.d0*pi**2)*Nc*&
	 ( 2.d0*(4.d0*sw**4*Qt**2-4.d0*sw**2*Qt*It+2.d0*It**2)*b3f(qsq,mt,mt)&
	+2.d0*qsq*(4.d0*sw**4*Qt**2-4.d0*sw**2*Qt*It+2.d0*It**2)*db3f(qsq,mt,mt)&
	-2.d0*It**2*mt**2*db0f(qsq,mt,mt) )&
!
	  +g**2/cw**2/(16.d0*pi**2)*Nc*&
	 ( 2.d0*(4.d0*sw**4*Qt**2-4.d0*sw**2*Qt*It+2.d0*It**2)*b3f(qsq,mc,mc)&
	+2.d0*qsq*(4.d0*sw**4*Qt**2-4.d0*sw**2*Qt*It+2.d0*It**2)*db3f(qsq,mc,mc)&
	-2.d0*It**2*mc**2*db0f(qsq,mc,mc) )&
!
	  +g**2/cw**2/(16.d0*pi**2)*Nc*&
	  (2.d0*(4.d0*sw**4*Qt**2-4.d0*sw**2*Qt*It+2.d0*It**2)*b3f(qsq,m0,m0)&
	+2.d0*qsq*(4.d0*sw**4*Qt**2-4.d0*sw**2*Qt*It+2.d0*It**2)*db3f(qsq,m0,m0) )&
!
	  +g**2/cw**2/(16.d0*pi**2)*Nc*&
	  (2.d0*(4.d0*sw**4*Qb**2-4.d0*sw**2*Qb*Ib+2.d0*Ib**2)*b3f(qsq,mb,mb)&
	+2.d0*qsq*(4.d0*sw**4*Qb**2-4.d0*sw**2*Qb*Ib+2.d0*Ib**2)*db3f(qsq,mb,mb)&
	-2.d0*Ib**2*mb**2*db0f(qsq,mb,mb) )&
!
	  +g**2/cw**2/(16.d0*pi**2)*Nc*&
	  (2.d0*(4.d0*sw**4*Qb**2-4.d0*sw**2*Qb*Ib+2.d0*Ib**2)*b3f(qsq,ms,ms)&
	+2.d0*qsq*(4.d0*sw**4*Qb**2-4.d0*sw**2*Qb*Ib+2.d0*Ib**2)*db3f(qsq,ms,ms)&
	-2.d0*Ib**2*ms**2*db0f(qsq,ms,ms) )&
!
	  +g**2/cw**2/(16.d0*pi**2)*Nc*&
	  (2.d0*(4.d0*sw**4*Qb**2-4.d0*sw**2*Qb*Ib+2.d0*Ib**2)*b3f(qsq,m0,m0)&
	+2.d0*qsq*(4.d0*sw**4*Qb**2-4.d0*sw**2*Qb*Ib+2.d0*Ib**2)*db3f(qsq,m0,m0))&
!
	  +g**2/cw**2/(16.d0*pi**2)*&
	  (2.d0*(4.d0*sw**4*Qe**2-4.d0*sw**2*Qe*Ie+2.d0*Ie**2)*b3f(qsq,mtau,mtau)&
	+2.d0*qsq*(4.d0*sw**4*Qe**2-4.d0*sw**2*Qe*Ie+2.d0*Ie**2)*db3f(qsq,mtau,mtau)&
	-2.d0*Ie**2*mtau**2*db0f(qsq,mtau,mtau) )&
!
	  +2.d0*g**2/cw**2/(16.d0*pi**2)*&
	  (2.d0*(4.d0*sw**4*Qe**2-4.d0*sw**2*Qe*Ib+2.d0*Ib**2)*b3f(qsq,m0,m0)&
	+2.d0*qsq*(4.d0*sw**4*Qe**2-4.d0*sw**2*Qe*Ib+2.d0*Ib**2)*db3f(qsq,m0,m0)  )&
!
	  +3.d0*g**2/cw**2/(16.d0*pi**2)*&
	  (2.d0*(2.d0*It**2)*b3f(qsq,m0,m0)+2.d0*qsq*(2.d0*It**2)*db3f(qsq,m0,m0))

	 end function

!#############################
!
!  GAUGE BOSON-LOOP CONTRIBUTIONS
!
!#############################

!---------------------------------------------
	double complex function PiGG_NG(qsq)
 	double precision, intent(in):: qsq

	PiGG_NG=&
	 g**2*sw**2/(16.d0*pi**2)*&
	 (&
	2.d0*mw**2*b0f(qsq,mw,mw)+b5f(qsq,mw,mw)&
	 )
	
	end function
!---------------------------------------------
	double complex function PiZG_NG(qsq)
 	double precision, intent(in):: qsq

	PiZG_NG=&
	 g**2*sw/cw/(16.d0*pi**2)*&
	 (&
	-2.d0*mw**2*sw**2*b0f(qsq,mw,mw)+1.d0/2.d0*(cw**2-sw**2)*b5f(qsq,mw,mw)&
	 )
	
	end function
!---------------------------------------------
	double complex function PiWW_NG(qsq)
 	double precision, intent(in):: qsq

	PiWW_NG=&
	 g**2/(16.d0*pi**2)*&
	 (&
	  mw**2*sw**4/cw**2*b0f(qsq,mw,mz)+mw**2*sw**2*b0f(qsq,mw,mphoton)+1.d0/4.d0*b5f(qsq,mw,mz)&
	 )
	
	end function
!---------------------------------------------
	double complex function PiZZ_NG(qsq)
 	double precision, intent(in):: qsq

	PiZZ_NG=&
	 g**2/cw**2/(16.d0*pi**2)*&
	 (&
	  2.d0*sw**4*cw**2*mz**2*b0f(qsq,mw,mw)+(cw**2-sw**2)**2/4.d0*b5f(qsq,mw,mw)&
	 )
	
	end function
!=============================================
	double complex function dPiGG_NG(qsq)
 	double precision, intent(in):: qsq

	dPiGG_NG=&
	 g**2*sw**2/(16.d0*pi**2)*&
	 (&
	2.d0*mw**2*db0f(qsq,mw,mw)+db5f(qsq,mw,mw)&
	 )
	
	end function
!---------------------------------------------
	double complex function dPiZG_NG(qsq)
 	double precision, intent(in):: qsq

	dPiZG_NG=&
	 g**2*sw/cw/(16.d0*pi**2)*&
	 (&
	-2.d0*mw**2*sw**2*db0f(qsq,mw,mw)+1.d0/2.d0*(cw**2-sw**2)*db5f(qsq,mw,mw)&
	 )
	
	end function
!---------------------------------------------
	double complex function dPiWW_NG(qsq)
 	double precision, intent(in):: qsq

	dPiWW_NG=&
	 g**2/(16.d0*pi**2)*&
	 (&
	  mw**2*sw**4/cw**2*db0f(qsq,mw,mz)+mw**2*sw**2*db0f(qsq,mw,mphoton)+1.d0/4.d0*db5f(qsq,mw,mz)&
	 )
	
	end function
!---------------------------------------------
	double complex function dPiZZ_NG(qsq)
 	double precision, intent(in):: qsq

	dPiZZ_NG=&
	 g**2/cw**2/(16.d0*pi**2)*&
	 (&
	  2.d0*sw**4*cw**2*mz**2*db0f(qsq,mw,mw)+(cw**2-sw**2)**2/4.d0*db5f(qsq,mw,mw)&
	 )
	
	end function
!=============================================
	double complex function PiWW_V(qsq)
 	double precision, intent(in):: qsq

	PiWW_V=&
	 g**2/(16.d0*pi**2)*&
	 (&
	 -sw**2*(&
	   16.d0*b22f(qsq,mw,mphoton)&
	       +qsq*(2.d0*b2f(qsq,mw,mphoton)&
	             +2.d0*b1f(qsq,mw,mphoton)&
	             +5.d0*b0f(qsq,mw,mphoton)&
	            )&
	        )&
	 -cw**2*(&
	    16.d0*b22f(qsq,mw,mz)&
	          +qsq*(2.d0*b2f(qsq,mw,mz)&
	               +2.d0*b1f(qsq,mw,mz)&
	               +5.d0*b0f(qsq,mw,mz)&
	               )&
	        )&
	 +3.d0*(cw**2*a0f(mz)+a0f(mw))&
	+mw**2+mz**2*cw**2-qsq &
	 )
	

	end function
!---------------------------------------------
	double complex function PiGG_V(qsq)
	double precision, intent(in):: qsq

	PiGG_V = &
	 g**2*sw**2/(16.d0*pi**2)*&
	 ( 6.d0*A0f(mw)&
	   -16.d0*b22f(qsq,mw,mw)&
	            -qsq*(2.d0*b2f(qsq,mw,mw)&
	             +2.d0*b1f(qsq,mw,mw)&
	             +5.d0*b0f(qsq,mw,mw)&
	             )&
	+2.d0*mw**2-qsq&
	 )

	end function
!---------------------------------------------
	double complex function PiZG_V(qsq)
	double precision, intent(in):: qsq

	PiZG_V =&
	 g**2*sw/cw/(16.d0*pi**2)*&
	 (&
	  -cw**2*(&
	   +16.d0*b22f(qsq,mw,mw)&
	       +qsq*(2.d0*b2f(qsq,mw,mw)&
	             +2.d0*b1f(qsq,mw,mw)&
	             +5.d0*b0f(qsq,mw,mw)&
	            )&
	 -6.d0*a0f(mw)&
	 )&
	+cw**2*(2.d0*mw**2-qsq)&
	 )

	end function
!---------------------------------------------
	double complex function PiZZ_V(qsq)
	double precision, intent(in):: qsq

	PiZZ_V=&
	 g**2/(16.d0*pi**2)/cw**2*&
	 (-cw**4*( &
	   16.d0*b22f(qsq,mw,mw)&
	       +qsq*(2.d0*b2f(qsq,mw,mw)&
	             +2.d0*b1f(qsq,mw,mw)&
	             +5.d0*b0f(qsq,mw,mw)&
	            )&
	        )&
	 +6.d0*cw**4*a0f(mw)&
	+cw**4*(2.d0*mw**2-qsq)&
	 )

	end function
!---------------------------------------------
	double complex function dPiWW_V(qsq)
	double precision, intent(in):: qsq

	dPiWW_V=&
	 g**2/(16.d0*pi**2)*&
	 ( -sw**2*(&
	   16.d0*db22f(qsq,mw,mphoton)&
	       +qsq*(2.d0*db2f(qsq,mw,mphoton)&
	             +2.d0*db1f(qsq,mw,mphoton)&
	             +5.d0*db0f(qsq,mw,mphoton)&
	            )&
	        )&
	 -cw**2*( &
	    16.d0*db22f(qsq,mw,mz)&
	          +qsq*(2.d0*db2f(qsq,mw,mz)&
	               +2.d0*db1f(qsq,mw,mz)&
	               +5.d0*db0f(qsq,mw,mz)&
	               )&
	        )&
	 )&
!
	 +g**2/(16.d0*pi**2)*&
	 (&
	 -sw**2*( &
	         2.d0*b2f(qsq,mw,mphoton)&
	         +2.d0*b1f(qsq,mw,mphoton)&
	         +5.d0*b0f(qsq,mw,mphoton)&
	        )&
	 -cw**2*( &
	           2.d0*b2f(qsq,mw,mz)&
	           +2.d0*b1f(qsq,mw,mz)&
	           +5.d0*b0f(qsq,mw,mz)&
	        )&
	 )&
!
	+g**2/(16.d0*pi**2)*(-1.d0)

	end function
!---------------------------------------------
	double complex function dPiGG_V(qsq)
	double precision, intent(in):: qsq

	dPiGG_V = &
	 -g**2*sw**2/(16.d0*pi**2)*&
	 (&
	   +16.d0*db22f(qsq,mw,mw)&
	            +(2.d0*b2f(qsq,mw,mw)&
	             +2.d0*b1f(qsq,mw,mw)&
	             +5.d0*b0f(qsq,mw,mw)&
	             )&
	       +qsq*(2.d0*db2f(qsq,mw,mw)&
	             +2.d0*db1f(qsq,mw,mw)&
	             +5.d0*db0f(qsq,mw,mw)&
	            )&
	+1.d0	 )


	end function
!---------------------------------------------
	double complex function dPiZG_V(qsq)
	double precision, intent(in):: qsq

	dPiZG_V =&
	 -g**2*sw/cw/(16.d0*pi**2)*&
	 (&
	 cw**2*(&
	   +16.d0*db22f(qsq,mw,mw)&
	       +     (2.d0*b2f(qsq,mw,mw)&
	             +2.d0*b1f(qsq,mw,mw)&
	             +5.d0*b0f(qsq,mw,mw)&
	            )&
	 )&
	 )&
!
	 -g**2*sw/cw/(16.d0*pi**2)*&
	 (&
	 cw**2*(&
	          +qsq*(2.d0*db2f(qsq,mw,mw)&
	             +2.d0*db1f(qsq,mw,mw)&
	             +5.d0*db0f(qsq,mw,mw)&
	            )&
	 )&
	+cw**2		 )

	end function
!---------------------------------------------
	double complex function dPiZZ_V(qsq)
	double precision, intent(in):: qsq

	dPiZZ_V =&
	 g**2/(16.d0*pi**2)/cw**2*&
	 (&
	 -cw**4*( &
	         2.d0*b2f(qsq,mw,mw)&
	         +2.d0*b1f(qsq,mw,mw)&
	         +5.d0*b0f(qsq,mw,mw)&
	        )&
	 )&
!
	 +g**2/(16.d0*pi**2)/cw**2*&
	 (-cw**4*( &
	   16.d0*db22f(qsq,mw,mw)&
	       +qsq*(2.d0*db2f(qsq,mw,mw)&
	             +2.d0*db1f(qsq,mw,mw)&
	             +5.d0*db0f(qsq,mw,mw)&
	            )&
	        )&
	-cw**4&
	 )

	end function
!==================================================
	double complex function PiWW_pinch(qsq)
	double precision, intent(in):: qsq

	PiWW_pinch=&
	 -4.d0*g**2/(16.d0*pi**2)*(qsq-mw**2)*&
	 (&
	 cw**2*b0f(qsq,mz,mw)&
	 +sw**2*b0f(qsq,mw,mphoton)&
	 ) 

	end function
!---------------------------------------------
	double complex function PiGG_pinch(qsq)
	double precision, intent(in):: qsq

	PiGG_pinch=&
	 -4.d0*g**2*sw**2/(16.d0*pi**2)*qsq*b0f(qsq,mw,mw) 
 
	 end function
!---------------------------------------------
	double complex function PiZG_pinch(qsq)
	double precision, intent(in):: qsq

	PiZG_pinch=&
	 -4.d0*g**2*sw/cw/(16.d0*pi**2)*cw**2*&
	 (qsq-1.d0/2.d0*mz**2)*b0f(qsq,mw,mw) 

	end function
!---------------------------------------------
	double complex function PiZZ_pinch(qsq)
	double precision, intent(in):: qsq

	PiZZ_pinch=&
	 -4.d0*g**2/cw**2*cw**4/(16.d0*pi**2)*(qsq-mz**2)*b0f(qsq,mw,mw)

	end function
!=====================================================
	double complex function dPiWW_pinch(qsq)
	double precision, intent(in):: qsq

	dPiWW_pinch=&
	 -4.d0*g**2/(16.d0*pi**2)*(qsq-mw**2)*&
	 (&
	 cw**2*db0f(qsq,mz,mw)&
	 +sw**2*db0f(qsq,mw,mphoton)&
	 )&
	 -4.d0*g**2/(16.d0*pi**2)*&
	 (&
	 cw**2*db0f(qsq,mz,mw)&
	 +sw**2*db0f(qsq,mw,mphoton)&
	 ) 

	end function
!---------------------------------------------
	double complex function dPiGG_pinch(qsq)
	double precision, intent(in):: qsq

	dPiGG_pinch=&
	 -4.d0*g**2*sw**2/(16.d0*pi**2)*b0f(qsq,mw,mw)&
	 -4.d0*g**2*sw**2/(16.d0*pi**2)*qsq*db0f(qsq,mw,mw) 
 
	 end function
!---------------------------------------------
	double complex function dPiZG_pinch(qsq)
	double precision, intent(in):: qsq

	dPiZG_pinch=&
	 -4.d0*g**2*sw/cw/(16.d0*pi**2)*cw**2*&
	 (qsq-1.d0/2.d0*mz**2)*db0f(qsq,mw,mw)&
	 -4.d0*g**2*sw/cw/(16.d0*pi**2)*cw**2*&
	 db0f(qsq,mw,mw) 

	end function
!---------------------------------------------
	double complex function dPiZZ_pinch(qsq)
	double precision, intent(in):: qsq

	dPiZZ_pinch=&
	 -4.d0*g**2/cw**2*cw**4/(16.d0*pi**2)*(qsq-mz**2)*&
	 db0f(qsq,mw,mw)&
	 -4.d0*g**2/cw**2*cw**4/(16.d0*pi**2)*&
	 b0f(qsq,mw,mw)

	end function
!=====================================================
	double complex function barPiWW_V(qsq)
	double precision, intent(in):: qsq

	barPiWW_V=PiWW_V(qsq)+PiWW_pinch(qsq)

	end function
!---------------------------------------------
	double complex function barPiGG_V(qsq)
	double precision, intent(in):: qsq

	barPiGG_V=PiGG_V(qsq)+PiGG_pinch(qsq)
 
	 end function
!---------------------------------------------
	double complex function barPiZG_V(qsq)
	double precision, intent(in):: qsq

	barPiZG_V=PiZG_V(qsq)+PiZG_pinch(qsq)

	end function
!---------------------------------------------
	double complex function barPiZZ_V(qsq)
	double precision, intent(in):: qsq

	barPiZZ_V=PiZZ_V(qsq)+PiZZ_pinch(qsq)

	end function
!---------------------------------------------
	double complex function dbarPiWW_V(qsq)
	double precision, intent(in):: qsq

	dbarPiWW_V=dPiWW_V(qsq)+dPiWW_pinch(qsq)

	end function
!---------------------------------------------
	double complex function dbarPiGG_V(qsq)
	double precision, intent(in):: qsq

	dbarPiGG_V=dPiGG_V(qsq)+dPiGG_pinch(qsq)
 
	 end function
!---------------------------------------------
	double complex function dbarPiZG_V(qsq)
	double precision, intent(in):: qsq

	dbarPiZG_V=dPiZG_V(qsq)+dPiZG_pinch(qsq)

	end function
!---------------------------------------------
	double complex function dbarPiZZ_V(qsq)
	double precision, intent(in):: qsq

	dbarPiZZ_V=dPiZZ_V(qsq)+dPiZZ_pinch(qsq)

	end function
!====================================================
	double complex function PiWW_B_WOH(qsq)
 	double precision, intent(in):: qsq

	PiWW_B_WOH=PiWW_NG(qsq)+barPiWW_V(qsq)
	
	end function
!---------------------------------------------
	double complex function PiGG_B_WOH(qsq)
 	double precision, intent(in):: qsq

	PiGG_B_WOH=PiGG_NG(qsq)+barPiGG_V(qsq)
	
	end function
!---------------------------------------------
	double complex function PiZG_B_WOH(qsq)
 	double precision, intent(in):: qsq

	PiZG_B_WOH=PiZG_NG(qsq)+barPiZG_V(qsq)

	end function
!---------------------------------------------
	double complex function PiZZ_B_WOH(qsq)
 	double precision, intent(in):: qsq

	PiZZ_B_WOH=PiZZ_NG(qsq)+barPiZZ_V(qsq)
	
	end function
!====================================================
	double complex function dPiWW_B_WOH(qsq)
 	double precision, intent(in):: qsq

	dPiWW_B_WOH=dPiWW_NG(qsq)+dbarPiWW_V(qsq)
	
	end function
!---------------------------------------------
	double complex function dPiGG_B_WOH(qsq)
 	double precision, intent(in):: qsq

	dPiGG_B_WOH=dPiGG_NG(qsq)+dbarPiGG_V(qsq)
	
	end function
!---------------------------------------------
	double complex function dPiZG_B_WOH(qsq)
 	double precision, intent(in):: qsq

	dPiZG_B_WOH=dPiZG_NG(qsq)+dbarPiZG_V(qsq)

	end function
!---------------------------------------------
	double complex function dPiZZ_B_WOH(qsq)
 	double precision, intent(in):: qsq

	dPiZZ_B_WOH=dPiZZ_NG(qsq)+dbarPiZZ_V(qsq)
	
	end function
!==================================================== !Note:these espressions are not included Higgs boson cont.
	double complex function PiWW_SM(qsq)
 	double precision, intent(in):: qsq

	PiWW_SM=PiWW_F(qsq)+PiWW_NG(qsq)+barPiWW_V(qsq)
	
	end function
!---------------------------------------------
	double complex function PiGG_SM(qsq)
 	double precision, intent(in):: qsq

	PiGG_SM=PiGG_F(qsq)+PiGG_NG(qsq)+barPiGG_V(qsq)
	
	end function
!---------------------------------------------
	double complex function PiZG_SM(qsq)
 	double precision, intent(in):: qsq

	PiZG_SM=PiZG_F(qsq)+PiZG_NG(qsq)+barPiZG_V(qsq)

	end function
!---------------------------------------------
	double complex function PiZZ_SM(qsq)
 	double precision, intent(in):: qsq

	PiZZ_SM=PiZZ_F(qsq)+PiZZ_NG(qsq)+barPiZZ_V(qsq)
	
	end function
!====================================================
	double complex function dPiWW_SM(qsq)
 	double precision, intent(in):: qsq

	dPiWW_SM=dPiWW_F(qsq)+dPiWW_NG(qsq)+dbarPiWW_V(qsq)
	
	end function
!---------------------------------------------
	double complex function dPiGG_SM(qsq)
 	double precision, intent(in):: qsq

	dPiGG_SM=dPiGG_F(qsq)+dPiGG_NG(qsq)+dbarPiGG_V(qsq)
	
	end function
!---------------------------------------------
	double complex function dPiZG_SM(qsq)
 	double precision, intent(in):: qsq

	dPiZG_SM=dPiZG_F(qsq)+dPiZG_NG(qsq)+dbarPiZG_V(qsq)

	end function
!---------------------------------------------
	double complex function dPiZZ_SM(qsq)
 	double precision, intent(in):: qsq

	dPiZZ_SM=dPiZZ_F(qsq)+dPiZZ_NG(qsq)+dbarPiZZ_V(qsq)
	
	end function
!---------------------------------------------
!KS added: dPiGG_top, are used for computations of dPi_GG_F(0)
        double complex function dPiGG_top(qsq)
        double precision, intent(in):: qsq
        dPiGG_top=&
         g**2*sw**2/(16.d0*pi**2)*3.d0*Qt**2*&
        (&
         8.d0*b3f(qsq,mt,mt)+8.d0*qsq*db3f(qsq,mt,mt)&
         )
         end function
!---------------------------------------------
        double complex function PiGG_top(qsq)
        double precision, intent(in):: qsq
         PiGG_top=&
         g**2*sw**2/(16.d0*pi**2)*Nc*Qt**2*&
        ( 8.d0*qsq*b3f(qsq,mt,mt))
         end function

	end module Gauge_boson_2p



