	module SM_Hdecay
        use SM_const
	use phase_space
	use pv
        use func_forQCDco
	implicit none
	contains
!-----------------------------------------
	double precision function htt_sm(mh)
	double precision,intent(in):: mh

	if (1.d0 .gt. 4.d0*mt**2/mh**2) then
	htt_sm=sqrt(2.d0)*G_F/(8.d0*pi)*nc*mt**2*mh*lambda(mt**2/mh**2,mt**2/mh**2)**(3.d0/2.d0)
	else 
	htt_sm=1.d-10
	end if

	end function
!-----------------------------------------
	double precision function hbb_sm(mh)
	double precision,intent(in):: mh

	if (1.d0 .gt. 4.d0*mb**2/mh**2) then
	hbb_sm=sqrt(2.d0)*G_F/(8.d0*pi)*nc*mb**2*mh*lambda(mb**2/mh**2,mb**2/mh**2)**(3.d0/2.d0)
	else 
	hbb_sm=1.d-10
	end if

	end function
!-----------------------------------------
	double precision function hcc_sm(mh)
	double precision,intent(in):: mh

	if (1.d0 .gt. 4.d0*mc**2/mh**2) then
	hcc_sm=sqrt(2.d0)*G_F/(8.d0*pi)*nc*mc**2*mh*lambda(mc**2/mh**2,mc**2/mh**2)**(3.d0/2.d0)
	else 
	hcc_sm=1.d-10
	end if

	end function
!-----------------------------------------
	double precision function hss_sm(mh)
	double precision,intent(in):: mh

	if (1.d0 .gt. 4.d0*ms**2/mh**2) then
	hss_sm=sqrt(2.d0)*G_F/(8.d0*pi)*nc*ms**2*mh*lambda(ms**2/mh**2,ms**2/mh**2)**(3.d0/2.d0)
	else 
	hss_sm=1.d-10
	end if

	end function
!-----------------------------------------
	double precision function htautau_sm(mh)
	double precision,intent(in):: mh

	if (1.d0 .gt. 4.d0*mtau**2/mh**2) then
	htautau_sm=sqrt(2.d0)*G_F/(8.d0*pi)*mtau**2*mh*lambda(mtau**2/mh**2,mtau**2/mh**2)**(3.d0/2.d0)
	else 
	htautau_sm=1.d-10
	end if

	end function
!-----------------------------------------
	double precision function hmumu_sm(mh)
	double precision,intent(in):: mh

	if (1.d0 .gt. 4.d0*mmu**2/mh**2) then
	hmumu_sm=sqrt(2.d0)*G_F/(8.d0*pi)*mmu**2*mh*lambda(mmu**2/mh**2,mmu**2/mh**2)**(3.d0/2.d0)
	else 
	hmumu_sm=1.d-10
	end if

	end function
!--------------------------------------------
	double precision function hww_2body(mh)
	double precision, intent(in):: mh
	double precision:: xw

	xw=4.d0*mw**2/mh**2
	hww_2body=g**2*mh**3/(64.d0*pi*mw**2)*dsqrt(1.d0-xw)*(1.d0-xw+3.d0/4.d0*xw**2)

	end function
!--------------------------------------------
	double precision function hww_3body(mh)
	double precision, intent(in):: mh

	hww_3body=3.d0*g**4*mh/(512.d0*pi**3)*F3body(mw/mh)

	end function
!--------------------------------------------
	double precision function hww_sm(mh)
	double precision, intent(in):: mh
	double precision:: m_p,m_m

	m_p=2.d0*mw+2.d0
	m_m=2.d0*mw-2.d0

	if (mh .gt. m_p) then
	hww_sm =hww_2body(mh)
	else if  (mh .lt. m_m) then
	hww_sm =hww_3body(mh) 
	else if (mh .ge. m_m  .and. mh .le. m_p)  then
	hww_sm =(hww_2body(m_p)-hww_3body(m_m))/(m_p-m_m)*(mh-m_m)+hww_3body(m_m)	
	else
	hww_sm = 1.d-30
	end if

	end function
!--------------------------------------------
	double precision function hzz_2body(mh)
	double precision, intent(in):: mh
	double precision:: xz
	xz=4.d0*mz**2/mh**2

	hzz_2body=g**2*mh**3/(128.d0*pi*mz**2*cw**2)*sqrt(1.d0-xz)*(1.d0-xz+3.d0/4.d0*xz**2)

	end function
!--------------------------------------------
	double precision function hzz_3body(mh)
	double precision, intent(in):: mh
	double precision:: xz
	xz=4.d0*mz**2/mh**2

	hzz_3body=g**4*mh/(2048.d0*pi**3*cw**4)*(7.d0-40.d0*sw**2/3.d0+160.d0*sw**4/9.d0)*F3body(mz/mh)

	end function
!--------------------------------------------
	double precision function hzz_sm(mh)
	double precision, intent(in):: mh
	double precision:: m_p,m_m

	m_p=2.d0*mz+2.d0
	m_m=2.d0*mz-2.d0

	if (mh .gt. m_p) then
	hzz_sm =hzz_2body(mh)
	else if  (mh .lt. m_m) then
	hzz_sm =hzz_3body(mh) 
	else if (mh .gt. m_m  .and. mh .lt. m_p)  then
	hzz_sm =(hzz_2body(m_p)-hzz_3body(m_m))/(m_p-m_m)*(mh-m_m)+hzz_3body(m_m)	
	else
	hzz_sm = 1.d-30
	end if

	end function
!--------------------------------------------------------------
        double complex function I_f(mh,mf)
	double precision, intent(in):: mh,mf
	I_f=-4.d0*mf**2*&
	  ( 2.d0/mh**2-(1.d0-4.d0*mf**2/mh**2)*c0f(0.d0,0.d0,mh**2,mf,mf,mf) )
	 end function
!------------------------------------------------------------------
 	double complex function I_A(mA,mf)
 	double precision, intent(in):: mA,mf
 	I_A=-4.d0*mf**2*c0f(0.d0,0.d0,mA**2,mf,mf,mf)
 	end function
!--------------------------------------------------------------
      double complex function I_W(mh)
	double precision, intent(in):: mh
	
	I_W= 2.d0*mw**2*(&
	 6.d0/mh**2+1.d0/mw**2+6.d0*(2.d0*mw**2/mh**2-1.d0)*&
	   c0f(0.d0,0.d0,mh**2,mw,mw,mw)&
	  )

	 end function
!--------------------------------------------------------------
      double complex function J_f(mh,mf)
	double precision, intent(in):: mh,mf

	J_f=&
	 -4.d0*mf**2/(sw*cw*(mh**2-mz**2))*&
	  (&
	 2.d0+(4.d0*mf**2-mh**2+mz**2)*c0f(0.d0,mz**2,mh**2,mf,mf,mf)&
	 +2.d0*mz**2/(mh**2-mz**2)*&
	     (&
	 b0f(mh**2,mf,mf)-b0f(mz**2,mf,mf)&
	     )&
	  )

	 end function
!--------------------------------------------------------------
      double complex function J_W(mh)
      double precision, intent(in):: mh

	J_W=&
	 2.d0*mw**2/(sw*cw*(mh**2-mz**2))*&
	  (&
	 (cw**2*(5.d0+mh**2/(2.d0*mw**2))-sw**2*(1.d0+mh**2/(2.d0*mw**2)))&
	 *(&
	   1.d0+2.d0*mw**2*c0f(0.d0,mz**2,mh**2,mw,mw,mw)&
	   +mz**2/(mh**2-mz**2)*(b0f(mh**2,mw,mw)-b0f(mz**2,mw,mw))&
	  )&
	 -6.d0*cw**2*(mh**2-mz**2)*c0f(0.d0,mz**2,mh**2,mw,mw,mw)&
	 +2.d0*sw**2*(mh**2-mz**2)*c0f(0.d0,mz**2,mh**2,mw,mw,mw)&
	  )

	 end function
!--------------------------------------------------------------
      double complex function I_S(mh,mch)
	double precision, intent(in):: mh,mch
	
	I_S=2.d0*vev**2/mh**2*&
	(&
	1.d0+2.d0*mch**2*c0f(0.d0,0.d0,mh**2,mch,mch,mch)&
	 )

	 end function
!--------------------------------------------------------------
      double complex function J_S(mh,mch)
	double precision, intent(in):: mh,mch

	J_S=&
	 2.d0*vev**2/(g*sw*(mh**2-mz**2))*&
	 (&
	 1.d0+2.d0*mch**2*c0f(0.d0,mz**2,mh**2,mch,mch,mch)&
	 +mz**2/(mh**2-mz**2)*&
	 (&
	 b0f(mh**2,mch,mch)-b0f(mz**2,mch,mch)&
	 )&
	 )

	 end function
!----------------------------------------
	double precision function hgg_sm(mh)
   	double precision, intent(in):: mh
      	hgg_sm=sqrt(2.d0)*G_F*alpha_s**2*mh**3/(128.d0*pi**3)*&
      	ABS(I_f(mh,mt)+I_f(mh,mb))**2

	 end function
!-----------------------------------------------
	double precision function hgamgam_sm(mh)
	double precision, intent(in):: mh
	
	hgamgam_sm=alpha_em**2*G_F/(128.d0*dsqrt(2.d0)*pi**3)*mh**3*&
	ABS(&
	Nc*Qt**2*I_f(mh,mt)& 
        +Nc*Qb**2*I_f(mh,mb)+Qe**2*I_f(mh,mtau)+I_W(mh)&
	)**2
	 end function 
!----------------------------------------
	double precision function hZgam_sm(mh)
	double precision, intent(in):: mh

	hZgam_sm=dsqrt(2.d0)*G_F*alpha_em**2*mh**3/(128.d0*pi**3)*&
	(1.d0-mz**2/mh**2)**3*&
	abs(&
        Nc*Qt*vt*J_f(mh,mt)& 
        +Nc*Qb*vb*J_f(mh,mb)+Qe*ve*J_f(mh,mtau)+J_W(mh)&
	)**2
	 end function 
!----------------------------------------
	 double precision function width_sm(mh)
	 double precision, intent(in):: mh

	 width_sm = htt_sm(mh)+hbb_sm(mh)+hcc_sm(mh)+hss_sm(mh)+htautau_sm(mh)+hmumu_sm(mh)&
	 +hww_sm(mh)+hzz_sm(mh)+hgg_sm(mh)+hgamgam_sm(mh)+hZgam_sm(mh)

	  end function 
!----------------------------------------
	double precision function Phi_phipZ(mphi,mphip,g_ppz)
	double precision, intent(in):: mphi,mphip,g_ppz
	double precision mphi_p,mphi_m

	mphi_p = mphip+mz + 4.d0
	mphi_m = mphip+mz - 1.d0
   
	if (mphi .gt. mphi_p) then 
	Phi_phipZ=g_ppz**2/(16.d0*pi)*mphi**3/mZ**2*lambda(mphip**2/mphi**2,mZ**2/mphi**2)**(3.d0/2.d0)
	else if (mphi .lt. mphi_m  .and. mphi .gt. mphip) then
	Phi_phipZ=12.d0*g**2/cw**2*g_ppz**2*mphi/(1024.d0*pi**3)*G3body(mphip**2/mphi**2,mZ**2/mphi**2)*&
	(7.d0-40.d0/3.d0*sw**2+160.d0/9.d0*sw**4)
	else if (mphi .lt. mphi_p  .and. mphi .gt. mphi_m) then
	Phi_phipZ=(g_ppz**2/(16.d0*pi)*mphi_p**3/mZ**2*lambda(mphip**2/mphi_p**2,mZ**2/mphi_p**2)**(3.d0/2.d0)-&
        12.d0*g**2/cw**2*g_ppz**2*mphi_m/(1024.d0*pi**3)*G3body(mphip**2/mphi_m**2,mZ**2/mphi_m**2)*&
	(7.d0-40.d0/3.d0*sw**2+160.d0/9.d0*sw**4)&
         )/(mphi_p-mphi_m)*(mphi-mphi_m)&
	+&
        12.d0*g**2/cw**2*g_ppz**2*mphi_m/(1024.d0*pi**3)*G3body(mphip**2/mphi_m**2,mZ**2/mphi_m**2)*&
	(7.d0-40.d0/3.d0*sw**2+160.d0/9.d0*sw**4)
        else 
	Phi_phipZ=1.d-30
	endif

	 end function 
!----------------------------------------
	double precision function Phi_phipW(mphi,mphip,g_ppw)
	double precision, intent(in):: mphi,mphip,g_ppw
	double precision mphi_p,mphi_m

	mphi_p = mphip+mw + 4.d0
	mphi_m = mphip+mw - 1.d0
  
	if (mphi .gt. mphi_p) then 
	Phi_phipW=&
	g_ppw**2/(16.d0*pi)*mphi**3/mw**2*lambda(mphip**2/mphi**2,mW**2/mphi**2)**(3.d0/2.d0)
	else if (mphi .gt. mphip  .and. mphi .lt. mphi_m) then
	Phi_phipW=36.d0*g**2*g_ppw**2*mphi/(512.d0*pi**3)*G3body(mphip**2/mphi**2,mw**2/mphi**2)
	else if (mphi .gt. mphi_m  .and. mphi .lt. mphi_p) then
	Phi_phipW=(g_ppw**2/(16.d0*pi)*mphi_p**3/mw**2*lambda(mphip**2/mphi_p**2,mW**2/mphi_p**2)**(3.d0/2.d0)&
        -36.d0*g**2*g_ppw**2*mphi_m/(512.d0*pi**3)*G3body(mphip**2/mphi_m**2,mw**2/mphi_m**2))/&
        (mphi_p-mphi_m)*(mphi-mphi_m)&
	+36.d0*g**2*g_ppw**2*mphi_m/(512.d0*pi**3)*G3body(mphip**2/mphi_m**2,mw**2/mphi_m**2)
        else
	Phi_phipW=1.d-30
	endif

	 end function 
!============ Functions given in Higgs Hunter's Guide ===================================
      double complex function f_HHG(x)
      double precision eta_p,eta_m
      double precision, intent(in):: x

         eta_p = 1.d0 + sqrt(1.d0-x)
         eta_m = 1.d0 - sqrt(1.d0-x)
         if (x .ge. 1.d0) then
         f_HHG=asin(sqrt(1.d0/x))**2.d0
         else 
         f_HHG= -1.d0/4.d0*(log(eta_p/eta_m)-ii*pi)**2
         endif
	 end function
!--------------------------------------------------------
      double complex function g_HHG(x)
      double precision eta_p,eta_m
      double precision, intent(in):: x

         eta_p = 1.d0 + sqrt(1.d0-x)
         eta_m = 1.d0 - sqrt(1.d0-x)
         if (x .ge. 1.d0) then
         g_HHG = sqrt(x-1.d0)*asin(sqrt(1.d0/x))
         else 
         g_HHG= 1.d0/2.d0*sqrt(1.d0-x)*(log(eta_p/eta_m)-ii*pi)
         endif

	 end function
!--------------------------------------------------------
      double complex function I1_HHG(tau,lam)
      double precision eta_p,eta_m
      double precision, intent(in):: tau,lam

         I1_HHG=(tau*lam)/(2.d0*(tau-lam))+(tau*lam)**2.d0/&
         (2.d0*(tau-lam)**2.d0)*( f_HHG(tau)-f_HHG(lam) )&
         +tau**2.d0*lam/(tau-lam)**2.d0*(g_HHG(tau)-g_HHG(lam) )

	 end function
!--------------------------------------------------------
	end module SM_Hdecay



