	module SM_const
        implicit none

!------   Fundermental constants ------------------------
        double precision::   alpha_em        
        double precision::   mz              
        double precision::   G_F             
        double precision::   delta_alpha     
        double precision::   alpha_s         
!----------------------------------------------------------------------------------------
        double precision::   mh         
        double precision::   mt         
        double precision::   mb         
        double precision::   mc         
        double precision::   mtau       
        double precision::   mmu  
        double precision::   mb_MS   
        double precision::   mc_MS   
!------   Outputs -------------------------------------------
	double precision :: sw
        double precision :: cw
        double precision :: g
        double precision :: gz
        double precision :: mw
        double precision:: vt
        double precision:: vb
        double precision:: ve
        double precision:: at
        double precision:: ab
        double precision:: ae
	double precision:: vev
        double precision:: vnu
        double precision:: anu
!------ MS-bar quark mass ---------------------------
        double precision,parameter::   ms   = 0.d0
!------   Fermion mass, chrge, etc.  ------------------------
        double precision,parameter:: Qt=2.d0/3.d0,Qb=-1.d0/3.d0,Qe=-1.d0,Nc=3.d0,It=1.d0/2.d0,Ib=-1.d0/2.d0,Ie=-1.d0/2.d0
        double precision,parameter:: femtb=0.389d0*1.d12            ! 1/GeV^2 > fb
        double precision,parameter:: second=1.519295d24             ! second > 1/GeV
        double precision,parameter:: pi=atan(1.d0)*4.d0
        double precision,parameter:: m0=0.d0  
        complex, parameter        :: ii=(0.d0,1.d0)
        double precision,parameter:: QED = 0.d0
        double precision,parameter:: mphoton=10.d0**(-7.d0)
        double precision,parameter :: msir   = 0.095d0  ! current mass in PDG
!------- lambda_QCD at eqch active flavor number ------------------
         double precision,parameter :: lam_QCD6   = 89.d0*10**(-3.d0)                    ! [1] 
         double precision,parameter :: lam_QCD5   = 210.d0*10**(-3.d0)                   ! [1] 
         double precision,parameter :: lam_QCD4   = 292.d0*10**(-3.d0)                   ! [1] 
         double precision,parameter :: lam_QCD3   = 332.d0*10**(-3.d0)                   !
!------   STU  arXiv:1209.2716 [hep-ph]------------------------
         double precision,parameter ::	Del_chisq68 = 2.30d0    ! Delta chisq value giving 68% CL with m=2
         double precision,parameter ::	Del_chisq95 = 5.99d0    ! Delta chisq value giving 95% CL with m=2
         double precision,parameter ::	s_cent=0.05d0           ! Central Value of S
         double precision,parameter ::	t_cent=0.08d0           ! Central Value of T 
         double precision,parameter ::	sigma_s=0.09d0          ! Standard Deviation of S
         double precision,parameter ::	sigma_t=0.07d0          ! Standard Deviation of T
         double precision,parameter ::	rho_st = 0.91d0         ! Correlation Factor in the case of Del U=0

	contains
!#############################################################
	end module SM_const
